<?php
/**
 * Copyright © 2015 Infomodus. All rights reserved.
 */

namespace Infomodus\Upslabel\Controller\Adminhtml\Pdflabels;

class One extends \Infomodus\Upslabel\Controller\Adminhtml\Pdflabels
{
    protected $_conf;
    protected $_pdf;
    protected $fileFactory;

    public function __construct(
        \Magento\Backend\App\Action\Context $context,
        \Magento\Framework\Registry $coreRegistry,
        \Magento\Backend\Model\View\Result\ForwardFactory $resultForwardFactory,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\App\Response\Http\FileFactory $fileFactory,
        \Infomodus\Upslabel\Helper\Config $conf,
        \Infomodus\Upslabel\Helper\Pdf $pdf
    )
    {
        $this->_conf = $conf;
        $this->_pdf = $pdf;
        $this->fileFactory = $fileFactory;
        parent::__construct($context, $coreRegistry, $resultForwardFactory, $resultPageFactory);
    }

    public function execute()
    {
        $labelId = $this->getRequest()->getParam('label_id', NULL);
        if ($labelId !== NULL) {
            $data = $this->_pdf->createPDF($labelId);
            if ($data !== FALSE) {
                return $this->fileFactory->create(
                    'ups_shipping_labels.pdf',
                    $data->render(),
                    \Magento\Framework\App\Filesystem\DirectoryList::VAR_DIR,
                    'application/pdf'
                );
            }
        }
    }
}
