<?php
/**
 * Copyright © 2015 Magento. All rights reserved.
 * See COPYING.txt for license details.
 */
namespace Infomodus\Upslabel\Observer;

use Magento\Framework\Event\ObserverInterface;

class OrderPlaceBefore implements ObserverInterface
{
    protected $_coreRegistry;
    protected $_handy;

    public function __construct(
        \Magento\Framework\Registry $registry,
        \Infomodus\Upslabel\Helper\Handy $handy
    )
    {
        $this->_coreRegistry = $registry;
        $this->_handy = $handy;
    }

    public function execute(\Magento\Framework\Event\Observer $observer)
    {
        $order = $observer->getEvent()->getOrder();
        if($this->_coreRegistry->registry('infomodus_upslabel_autocreate_label') === NULL) {
            if (!$order->getId()) {
                $this->_coreRegistry->register('infomodus_upslabel_autocreate_label', ['order_id' => NULL, 'status' => NULL]);
            } else {
                $orderOld = $this->_handy->objectManager->get('Magento\Sales\Model\Order')->load($order->getId());
                $this->_coreRegistry->register('infomodus_upslabel_autocreate_label', ['order_id' => $orderOld->getId(), 'status' => $orderOld->getStatus()]);
            }
        }
        else {
            $this->_coreRegistry->unregister('infomodus_upslabel_autocreate_label');
        }
        return $this;
    }
}
